## gmsh 2.8.5+dfsg

=== CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

# do not warn about non-definition of WIN32 on cygwin
set(CMAKE_LEGACY_CYGWIN_WIN32 0) 

# if CMAKE_BUILD_TYPE is specified use it; otherwise set the default
# build type to "RelWithDebInfo" ("-O2 -g" with gcc) prior to calling
# project()
if(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose build type")
else(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose build type")
endif(DEFINED CMAKE_BUILD_TYPE)

project(gmsh CXX C)

# this variable controls the default value of the options which are normally set
# to ON (useful if you want to configure a minimal version of Gmsh: e.g. "cmake
# -DDEFAULT=0 -DENABLE_POST=1 -DENABLE_PARSER=1")
set(DEFAULT ON CACHE INTERNAL "Default value for enabled-by-default options")

macro(opt OPTION HELP VALUE)
  option(ENABLE_${OPTION} ${HELP} ${VALUE})
  set(OPT_TEXI "${OPT_TEXI}\n@item ENABLE_${OPTION}\n${HELP} (default: ${VALUE})")
endmacro(opt)

opt(3M "Enable proprietary 3M extension" OFF)
opt(ACIS "Enable ACIS geometrical models (experimental)" ${DEFAULT})
opt(ANN "Enable ANN (used for fast point search in mesh/post)" ${DEFAULT})
opt(BAMG "Enable Bamg 2D anisotropic mesh generator" ${DEFAULT})
opt(BFGS "Enable BFGS (used by some mesh optimizers)" ${DEFAULT})
opt(BLAS_LAPACK "Enable BLAS/Lapack for linear algebra (required for meshing)" ON)
opt(BLOSSOM "Enable Blossom algorithm (needed for full quad meshing)" ${DEFAULT})
opt(BUILD_LIB "Enable 'lib' target for building static Gmsh library" OFF)
opt(BUILD_SHARED "Enable 'shared' target for building shared Gmsh library" OFF)
opt(BUILD_DYNAMIC "Enable dynamic Gmsh executable (linked with shared lib)" OFF)
opt(BUILD_ANDROID "Enable Android NDK library target (experimental)" OFF)
opt(BUILD_IOS "Enable iOS (ARM) library target (experimental)" OFF)
opt(CGNS "Enable CGNS mesh export (experimental)" OFF)
opt(CAIRO "Enable Cairo to render fonts (experimental)" ${DEFAULT})
opt(CHACO "Enable Chaco mesh partitioner (alternative to Metis)" ${DEFAULT})
opt(COMPRESSED_IO "Enable compressed (gzip) input/output using zlib" OFF)
opt(DINTEGRATION "Enable discrete integration (needed for levelsets)" ${DEFAULT})
opt(FLTK "Enable FLTK graphical user interface (requires mesh/post)" ${DEFAULT})
opt(FOURIER_MODEL "Enable Fourier geometrical models (experimental)" OFF)
opt(GMM "Enable GMM linear solvers (simple alternative to PETSc)" ${DEFAULT})
opt(GRAPHICS "Enable building graphics lib even without GUI (advanced)" OFF)
opt(KBIPACK "Enable Kbipack (neeeded by homology solver)" ${DEFAULT})
opt(MATHEX "Enable math expression parser (used by plugins and options)" ${DEFAULT})
opt(MED "Enable MED mesh and post file formats" ${DEFAULT})
opt(MESH "Enable mesh module (required by GUI)" ${DEFAULT})
opt(METIS "Enable Metis mesh partitioner" ${DEFAULT})
opt(MMG3D "Enable MMG3D 3D anisotropic mesh refinement" ${DEFAULT})
opt(MPEG_ENCODE "Enable built-in MPEG movie encoder" ${DEFAULT})
opt(MPI "Enable MPI (mostly for parser and solver - mesh generation is sequential)" OFF)
opt(MSVC_STATIC_RUNTIME "Enable static Visual C++ runtime" OFF)
opt(MUMPS "Enable MUMPS sparse direct linear solver" OFF)
opt(NATIVE_FILE_CHOOSER "Enable native file chooser in GUI" ${DEFAULT})
opt(NETGEN "Enable Netgen 3D frontal mesh generator" ${DEFAULT})
opt(NUMPY "Enable conversion between fullMatrix and numpy array (requires SWIG)" OFF)
opt(OCC "Enable Open CASCADE geometrical models" ${DEFAULT})
opt(ONELAB "Enable ONELAB solver interface" ${DEFAULT})
opt(ONELAB2 "Enable experimental ONELAB-Cloud solver interface" OFF)
opt(ONELAB_METAMODEL "Enable ONELAB metamodels (experimental)" ${DEFAULT})
opt(OPENMP "Enable OpenMP (experimental)" OFF)
opt(OPTHOM "Enable high-order mesh optimization tools" ${DEFAULT})
opt(OS_SPECIFIC_INSTALL "Enable OS-specific (e.g. app bundle) installation" ${DEFAULT})
opt(OSMESA "Enable OSMesa for offscreen rendering (experimental)" OFF)
opt(PARSER "Enable GEO file parser (required for .geo/.pos files)" ${DEFAULT})
opt(PETSC "Enable PETSc linear solvers (required for SLEPc)" ${DEFAULT})
opt(PLUGINS "Enable post-processing plugins" ${DEFAULT})
opt(POST "Enable post-processing module (required by GUI)" ${DEFAULT})
opt(POPPLER "Enable Poppler for displaying PDF documents (experimental)" OFF)
opt(QT "Enable dummy QT graphical interface proof-of-concept (experimental)" OFF)
opt(RTREE "Enable RTREE (used for quad/hex mesh generation)" ${DEFAULT})
opt(SALOME "Enable Salome routines for CAD healing" ${DEFAULT})
opt(SGEOM "Enable SGEOM interface to OCC (experimental)" OFF)
opt(SLEPC "Enable SLEPc eigensolvers (required for conformal compounds)" ${DEFAULT})
opt(SOLVER "Enable built-in finite element solvers (required for compounds)" ${DEFAULT})
opt(TAUCS "Enable Taucs linear solver (alternative to PETSc)" ${DEFAULT})
opt(TCMALLOC "Enable libtcmalloc, a fast malloc implementation but that does not release memory" OFF)
opt(TETGEN "Enable Tetgen 3D initial mesh generator" ${DEFAULT})
opt(TETGEN_OLD "Enable older version of Tetgen" OFF)
opt(VORO3D "Enable Voro3D (for hex meshing, experimental)" ${DEFAULT})
opt(WRAP_JAVA "Enable generation of Java wrappers (experimental)" OFF)
opt(WRAP_PYTHON "Enable generation of Python wrappers" OFF)

set(GMSH_MAJOR_VERSION 2)
set(GMSH_MINOR_VERSION 8)
set(GMSH_PATCH_VERSION 5)
set(GMSH_EXTRA_VERSION "" CACHE STRING "Gmsh extra version string")

set(GMSH_VERSION "${GMSH_MAJOR_VERSION}.${GMSH_MINOR_VERSION}")
set(GMSH_VERSION "${GMSH_VERSION}.${GMSH_PATCH_VERSION}${GMSH_EXTRA_VERSION}")
set(GMSH_SHORT_LICENSE "GNU General Public License")

set(GMSH_API
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GmshConfig.h 
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GmshVersion.h
  Common/Gmsh.h Common/Context.h Common/GmshDefines.h Common/GmshMessage.h
    Common/VertexArray.h Common/Octree.h Common/OctreeInternals.h 
    Common/OS.h Common/StringUtils.h Common/OpenFile.h
    Common/onelab.h Common/GmshSocket.h Common/onelabUtils.h
  Numeric/Numeric.h Numeric/GaussIntegration.h Numeric/polynomialBasis.h
    Numeric/JacobianBasis.h Numeric/MetricBasis.h Numeric/bezierBasis.h Numeric/fullMatrix.h
    Numeric/simpleFunction.h Numeric/cartesian.h Numeric/ElementType.h
  Geo/GModel.h Geo/GEntity.h Geo/GPoint.h Geo/GVertex.h Geo/GEdge.h 
    Geo/GFace.h Geo/GRegion.h Geo/GEdgeLoop.h Geo/GEdgeCompound.h 
    Geo/GFaceCompound.h Geo/GRegionCompound.h Geo/GRbf.h Geo/MVertex.h
    Geo/MVertexBoundaryLayerData.h Geo/MEdge.h 
    Geo/MFace.h Geo/MElement.h Geo/MElementOctree.h Geo/MPoint.h Geo/MLine.h 
    Geo/MTriangle.h Geo/MQuadrangle.h Geo/MTetrahedron.h Geo/MHexahedron.h 
    Geo/MPrism.h Geo/MPyramid.h Geo/MElementCut.h Geo/MElementOctree.h 
    Geo/discreteVertex.h Geo/discreteEdge.h Geo/discreteFace.h Geo/discreteRegion.h 
    Geo/SPoint2.h Geo/SPoint3.h Geo/SVector3.h Geo/STensor3.h Geo/SBoundingBox3d.h 
    Geo/Pair.h Geo/Range.h Geo/SOrientedBoundingBox.h 
    Geo/CellComplex.h Geo/ChainComplex.h Geo/Cell.h Geo/Homology.h Geo/Chain.h 
    Geo/partitionEdge.h Geo/CGNSOptions.h Geo/gmshLevelset.h Geo/boundaryLayersData.h
  Mesh/meshGEdge.h Mesh/meshGFace.h Mesh/meshGFaceOptimize.h 
    Mesh/meshGFaceElliptic.h Mesh/meshPartition.h Mesh/meshGFaceDelaunayInsertion.h 
    Mesh/simple3D.h Mesh/meshPartitionOptions.h Mesh/directions3D.h Mesh/yamakawa.h
    Mesh/Voronoi3D.h Mesh/Levy3D.h Mesh/periodical.h Mesh/meshMetric.h
  Numeric/mathEvaluator.h
  Solver/dofManager.h Solver/femTerm.h Solver/laplaceTerm.h Solver/elasticityTerm.h
    Solver/crossConfTerm.h Solver/orthogonalTerm.h
    Solver/linearSystem.h Solver/linearSystemGMM.h Solver/linearSystemCSR.h 
    Solver/linearSystemFull.h Solver/elasticitySolver.h Solver/sparsityPattern.h 
    Solver/groupOfElements.h Solver/linearSystemPETSc.h Solver/linearSystemMUMPS.h
  Post/PView.h Post/PViewData.h Plugin/PluginManager.h Post/OctreePost.h 
  Post/PViewDataList.h Post/PViewDataGModel.h Post/PViewOptions.h Post/ColorTable.h
   Numeric/nodalBasis.h
  Graphics/drawContext.h
  contrib/kbipack/gmp_normal_form.h contrib/kbipack/gmp_matrix.h 
    contrib/kbipack/gmp_blas.h contrib/kbipack/mpz.h
  contrib/DiscreteIntegration/Integration3D.h
  contrib/HighOrderMeshOptimizer/OptHOM.h contrib/HighOrderMeshOptimizer/OptHomMesh.h
  contrib/HighOrderMeshOptimizer/OptHomRun.h contrib/HighOrderMeshOptimizer/ParamCoord.h
  contrib/HighOrderMeshOptimizer/OptHomFastCurving.h contrib/HighOrderMeshOptimizer/SuperEl.h
  contrib/MathEx/mathex.h)

get_property(IAMCHILD DIRECTORY  PROPERTY PARENT_DIRECTORY)
if(IAMCHILD)
  set(GMSH_API ${GMSH_API} PARENT_SCOPE)
endif(IAMCHILD)

execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE 
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND hostname OUTPUT_VARIABLE HOSTNAME 
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND whoami OUTPUT_VARIABLE PACKAGER 
                OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT DATE)
  set(DATE "unknown")
endif(NOT DATE)
set(GMSH_DATE "${DATE}")

if(NOT HOSTNAME)
  set(HOSTNAME "unknown")
endif(NOT HOSTNAME)
set(GMSH_HOST "${HOSTNAME}")

if(NOT PACKAGER)
  set(PACKAGER "unknown")
endif(NOT PACKAGER)
set(GMSH_PACKAGER "${PACKAGER}")

if(APPLE)
  set(GMSH_OS "MacOSX")
elseif(CYGWIN)
  set(GMSH_OS "Windows")
else(APPLE)
  set(GMSH_OS "${CMAKE_SYSTEM_NAME}")
endif(APPLE)

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXCompilerFlag)

if(MSVC)
  # remove annoying warning about bool/int cast performance
  set(GMSH_CONFIG_PRAGMAS "#pragma warning(disable:4800 4244 4267)")
  if(ENABLE_MSVC_STATIC_RUNTIME)
    foreach(VAR
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${VAR} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${VAR} "${${VAR}}")
      endif(${VAR} MATCHES "/MD")
    endforeach(VAR)
  endif(ENABLE_MSVC_STATIC_RUNTIME)
endif(MSVC)

if(ENABLE_OPENMP)
  find_package(OpenMP)
  if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  endif(OPENMP_FOUND)
endif(ENABLE_OPENMP)

macro(append_gmsh_src DIRNAME FILES)
  foreach(FILE ${FILES})
    list(APPEND LIST ${DIRNAME}/${FILE})
  endforeach(FILE)
  set(GMSH_SRC ${GMSH_SRC};${LIST} PARENT_SCOPE)
  set(GMSH_DIRS ${GMSH_DIRS};${DIRNAME} PARENT_SCOPE)
endmacro(append_gmsh_src)

macro(find_all_libraries VARNAME LISTNAME PATH SUFFIX)
  set(${VARNAME})
  list(LENGTH ${LISTNAME} NUM_LIST)
  foreach(LIB ${${LISTNAME}})
    find_library(FOUND_LIB ${LIB} PATHS ${PATH} PATH_SUFFIXES ${SUFFIX})
    if(FOUND_LIB)
      list(APPEND ${VARNAME} ${FOUND_LIB})
    endif(FOUND_LIB)
    unset(FOUND_LIB CACHE)
  endforeach(LIB)
  list(LENGTH ${VARNAME} NUM_FOUND_LIBRARIES)
  if(NUM_FOUND_LIBRARIES LESS NUM_LIST)
    set(${VARNAME})
  endif(NUM_FOUND_LIBRARIES LESS NUM_LIST)
endmacro(find_all_libraries)

macro(set_config_option VARNAME STRING)
  set(${VARNAME} TRUE)
  list(APPEND CONFIG_OPTIONS ${STRING})
  message(STATUS "Found " ${STRING})
endmacro(set_config_option)

# check if the machine is 64 bits (this is more reliable than using
# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
# machines)
check_type_size("void*" SIZEOF_VOID_P)
if(SIZEOF_VOID_P EQUAL 8)
  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
endif(SIZEOF_VOID_P EQUAL 8)

if(ENABLE_BLAS_LAPACK)
  if(BLAS_LAPACK_LIBRARIES)
    # use libs as specified in the BLAS_LAPACK_LIBRARIES variable
    set_config_option(HAVE_BLAS "Blas(Custom)")
    set_config_option(HAVE_LAPACK "Lapack(Custom)")

=== Common/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC  
  Gmsh.cpp
    GmshRemote.cpp
    GmshMessage.cpp
  gmshPopplerWrapper.cpp
  Context.cpp
  Options.cpp
  CommandLine.cpp
  OS.cpp
  OpenFile.cpp
  CreateFile.cpp
  VertexArray.cpp
  SmoothData.cpp
  Octree.cpp 
    OctreeInternals.cpp
  StringUtils.cpp
  ListUtils.cpp
  TreeUtils.cpp avl.cpp
  MallocUtils.cpp
  onelabUtils.cpp
  GamePad.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Common "${SRC};${HDR}")

=== Fltk/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  FlGui.cpp
    graphicWindow.cpp
      openglWindow.cpp
    optionWindow.cpp
      colorbarWindow.cpp
    drawContextFltkCairo.cpp
    drawContextFltkStringTexture.cpp
    gamepadWindow.cpp
    fieldWindow.cpp
    pluginWindow.cpp
    statisticsWindow.cpp
    visibilityWindow.cpp
    highOrderToolsWindow.cpp
    clippingWindow.cpp
    manipWindow.cpp
    contextWindow.cpp
    helpWindow.cpp
    fileDialogs.cpp
    extraDialogs.cpp
    projectionEditor.cpp
    classificationEditor.cpp
    partitionDialog.cpp
    onelabGroup.cpp
    inputValue.cpp inputRegion.cpp
    viewButton.cpp solverButton.cpp
    Navigator.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Fltk "${SRC};${HDR}")

=== Geo/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  boundaryLayersData.cpp
  closestPoint.cpp
  intersectCurveSurface.cpp
  GEntity.cpp STensor3.cpp
    GVertex.cpp GEdge.cpp GFace.cpp GRegion.cpp
    GEdgeLoop.cpp GEdgeCompound.cpp GFaceCompound.cpp
  GRegionCompound.cpp GRbf.cpp
    gmshVertex.cpp gmshEdge.cpp gmshFace.cpp gmshRegion.cpp
   gmshSurface.cpp
   OCCVertex.cpp OCCEdge.cpp OCCFace.cpp OCCRegion.cpp
    discreteEdge.cpp discreteFace.cpp discreteRegion.cpp
    fourierEdge.cpp fourierFace.cpp fourierProjectionFace.cpp
  ACISVertex.cpp
  ACISEdge.cpp
  ACISFace.cpp
  GModel.cpp
    GModelVertexArrays.cpp
    GModelFactory.cpp
    GModelIO_GEO.cpp GModelIO_ACIS.cpp GModelIO_OCC.cpp 
      GModelIO_Fourier.cpp OCC_Connect.cpp
    GModelIO_MSH.cpp GModelIO_MSH2.cpp GModelIO_VTK.cpp GModelIO_POS.cpp 
      GModelIO_CGNS.cpp GModelIO_MED.cpp GModelIO_MESH.cpp GModelIO_STL.cpp 
      GModelIO_PLY.cpp GModelIO_VRML.cpp GModelIO_UNV.cpp GModelIO_BDF.cpp 
      GModelIO_IR3.cpp GModelIO_DIFF.cpp GModelIO_GEOM.cpp GModelIO_INP.cpp
      GModelIO_MAIL.cpp GModelIO_P3D.cpp GModelIO_SGEOM.cpp GModelIO_CELUM.cpp
      GModelIO_ACTRAN.cpp GModelIO_SU2.cpp
  ExtrudeParams.cpp
  Geo.cpp
  GeoStringInterface.cpp GeoInterpolation.cpp
  gmshLevelset.cpp
  findLinks.cpp
  SOrientedBoundingBox.cpp
  GeomMeshMatcher.cpp
  MVertex.cpp
  MEdge.cpp
  MFace.cpp
  MElement.cpp MElementOctree.cpp
    MLine.cpp MTriangle.cpp MQuadrangle.cpp MTetrahedron.cpp
    MHexahedron.cpp MPrism.cpp MPyramid.cpp MElementCut.cpp MSubElement.cpp
  MZone.cpp MZoneBoundary.cpp
  Cell.cpp CellComplex.cpp ChainComplex.cpp Homology.cpp Chain.cpp
  Curvature.cpp
  MVertexBoundaryLayerData.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Geo "${SRC};${HDR}")

=== Graphics/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  Camera.cpp 
  Trackball.cpp 
  ReadImg.cpp 
  drawContext.cpp 
  drawMesh.cpp 
  drawGeom.cpp 
  drawPost.cpp 
  drawAxes.cpp 
  drawScales.cpp 
  drawGraph2d.cpp 
  drawGlyph.cpp 
  gl2ps.cpp
  gl2gif.cpp
  gl2jpeg.cpp
  gl2png.cpp
  gl2ppm.cpp
  gl2yuv.cpp
  gl2pgf.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Graphics "${SRC};${HDR}")

=== Mesh/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  Generator.cpp
    meshGEdge.cpp 
      meshGEdgeExtruded.cpp
    meshGFace.cpp 
    meshGFaceElliptic.cpp
      meshGFaceTransfinite.cpp meshGFaceExtruded.cpp 
      meshGFaceBamg.cpp meshGFaceBDS.cpp meshGFaceDelaunayInsertion.cpp 
      meshGFaceLloyd.cpp meshGFaceOptimize.cpp 
      meshGFaceQuadrilateralize.cpp 
    meshGRegion.cpp 
      meshGRegionDelaunayInsertion.cpp meshGRegionTransfinite.cpp 
      meshGRegionExtruded.cpp  meshGRegionCarveHole.cpp 
      meshGRegionLocalMeshMod.cpp meshGRegionMMG3D.cpp
    meshMetric.cpp
    BackgroundMesh.cpp 
    qualityMeasures.cpp 
    BoundaryLayers.cpp 
    BDS.cpp 
    HighOrder.cpp 
    meshPartition.cpp
    meshRefine.cpp
    multiscalePartition.cpp
    QuadTriUtils.cpp
      QuadTriExtruded2D.cpp QuadTriExtruded3D.cpp QuadTriTransfinite3D.cpp
    simple3D.cpp
  DivideAndConquer.cpp
    Voronoi3D.cpp
    Levy3D.cpp
    periodical.cpp
    directions3D.cpp
    filterElements.cpp
    yamakawa.cpp
    Field.cpp
    CenterlineField.cpp
    surfaceFiller.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Mesh "${SRC};${HDR}")

=== Numeric/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  Numeric.cpp
    fullMatrix.cpp
  BasisFactory.cpp
  discreteFrechetDistance.cpp
  miniBasis.cpp
    nodalBasis.cpp
	polynomialBasis.cpp
	pyramidalBasis.cpp
	BergotBasis.cpp
	jacobiPolynomials.cpp
	legendrePolynomials.cpp
    bezierBasis.cpp
    JacobianBasis.cpp
    MetricBasis.cpp
    pointsGenerators.cpp
  ElementType.cpp
  GaussIntegration.cpp
    GaussQuadratureLin.cpp
    GaussQuadratureTri.cpp
    GaussQuadratureQuad.cpp
    GaussQuadratureTet.cpp
    GaussQuadratureHex.cpp
    GaussQuadraturePri.cpp
    GaussQuadraturePyr.cpp
    GaussLegendreSimplex.cpp
  GaussJacobi1D.cpp
  HilbertCurve.cpp
 robustPredicates.cpp
 decasteljau.cpp
  mathEvaluator.cpp
  Iso.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Numeric "${SRC};${HDR}")

=== Parser/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  Gmsh.tab.cpp
  Gmsh.yy.cpp
  FunctionManager.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Parser "${SRC};${HDR}")

=== Plugin/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  Plugin.cpp PluginManager.cpp
  Levelset.cpp
  CutPlane.cpp CutSphere.cpp Isosurface.cpp
  Smooth.cpp CutParametric.cpp
  Lambda2.cpp
  Eigenvectors.cpp Eigenvalues.cpp
  StreamLines.cpp Particles.cpp CutGrid.cpp CutBox.cpp
  Transform.cpp
  LongitudeLatitude.cpp
  Triangulate.cpp Tetrahedralize.cpp
  Warp.cpp SphericalRaise.cpp
  Skin.cpp
  MathEval.cpp ModifyComponent.cpp ExtractElements.cpp
  MakeSimplex.cpp
  Integrate.cpp Gradient.cpp Curl.cpp Divergence.cpp
  Annotate.cpp Remove.cpp
  Probe.cpp MinMax.cpp
  HarmonicToTime.cpp ModulusPhase.cpp
  HomologyComputation.cpp HomologyPostProcessing.cpp
  Distance.cpp ExtractEdges.cpp NearestNeighbor.cpp
  AnalyseCurvedMesh.cpp
  CurvedBndDist.cpp
  FieldFromAmplitudePhase.cpp
  Bubbles.cpp NearToFarField.cpp
  DiscretizationError.cpp
  Scal2Tens.cpp Scal2Vec.cpp
  CutMesh.cpp
  NewView.cpp
  SimplePartition.cpp Crack.cpp
  FaultZone.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(Plugin "${SRC};${HDR}")

=== Post/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  PView.cpp PViewIO.cpp PViewVertexArrays.cpp
    PViewData.cpp PViewDataIO.cpp
      PViewDataList.cpp PViewDataListIO.cpp
      PViewDataGModel.cpp PViewDataGModelIO.cpp
    PViewOptions.cpp
    PViewFactory.cpp
    PViewAsSimpleFunction.cpp
  adaptiveData.cpp shapeFunctions.cpp
  OctreePost.cpp
  ColorTable.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Post "${SRC};${HDR}")

=== Qt/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  QGui.cpp
  GLWidget.cpp
  graphicWindow.cpp
)

set(MOC_HDR
  GLWidget.h
  graphicWindow.h
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Qt "${SRC};${HDR}")

foreach(FILE ${MOC_HDR})
  list(APPEND MOC_LIST Qt/${FILE})
endforeach(FILE)
set(GMSH_MOC_HDR ${GMSH_MOC_HDR};${MOC_LIST} PARENT_SCOPE)

=== Solver/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <gmsh@geuz.org>.

set(SRC
  linearSystem.cpp
  linearSystemCSR.cpp
  linearSystemPETSc.cpp
  linearSystemMUMPS.cpp
  dofManager.cpp
  groupOfElements.cpp
  elasticityTerm.cpp
elasticitySolver.cpp
  SElement.cpp
  eigenSolver.cpp
  multiscaleLaplace.cpp
functionSpace.cpp
  filters.cpp
  frameSolver.cpp
  sparsityPattern.cpp
  STensor43.cpp
  STensor33.cpp
  STensor53.cpp
  STensor63.cpp
terms.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Solver "${SRC};${HDR}")

=== debian/changelog ===
gmsh (2.8.5+dfsg-1.1ubuntu2) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 00:19:25 +0000

gmsh (2.8.5+dfsg-1.1ubuntu1) vivid; urgency=medium

  * Resynchronise with Debian.  Remaining changes:
    - Enable mpi on armhf.
    - Enable building on any architectures.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 02 Dec 2014 15:46:12 +0000

gmsh (2.8.5+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New patch fix-cmake-hdf5.patch to support hdf5 1.8.13 new packaging
    layout (closes: #756472).

 -- Gilles Filippini <pini@debian.org>  Fri, 25 Jul 2014 00:43:50 +0200

gmsh (2.8.5+dfsg-1) unstable; urgency=medium

  * [6fbfd92] Add Files-Excluded into d/copyright
  * [d31524d] Refresh patches.
  * [d43e2c4] Imported Upstream version 2.8.5+dfsg. (Closes: #751464, #749679)
  * [4766758] Remove alauzet patch, accepted by upstream.
  * [a70136f] Add autopkgtest.

 -- Anton Gladky <gladk@debian.org>  Fri, 25 Jul 2014 22:21:57 +0200

gmsh (2.8.4+dfsg-1) unstable; urgency=medium

  * [09d4b69] Imported Upstream version 2.8.4+dfsg
  * [85f9ea7] Refresh patches.
  * [df66b87] Enable tetgen. Thanks to Christophe Trophime.
  * [3d7eed8] Update package description.

 -- Anton Gladky <gladk@debian.org>  Mon, 10 Feb 2014 21:24:32 +0100

gmsh (2.8.3+dfsg-5) unstable; urgency=medium

  * [6168e45] Return back python-gmsh and gmsh-doc removed accidentally 
              in last uploads. (Closes: #729653)
  * [a6c5815] Use wrap-and-sort.
  * [e1cb0a0] Set Standards-Version: 3.9.5. No changes.
  * [7a492a8] Remove fopenmp option to escape race condition. (Closes: #737103)
  * [cfdec5c] Enable powerpcspe arch. (Closes: #735018)

 -- Anton Gladky <gladk@debian.org>  Thu, 06 Feb 2014 22:51:15 +0100

gmsh (2.8.3+dfsg-4ubuntu2) trusty; urgency=medium

  * Rebuild against oce 0.15.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 21 Mar 2014 14:52:40 +0000

gmsh (2.8.3+dfsg-4ubuntu1) trusty; urgency=medium

  * Enable mpi on armhf.
  * Enable building on any architectures.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 18:30:27 +0000

gmsh (2.8.3+dfsg-4build1) trusty; urgency=medium

  * No-change rebuild for libopenmpi1.3 -> libopenmpi1.6 transition.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 16 Dec 2013 17:23:32 -0500

gmsh (2.8.3+dfsg-4) unstable; urgency=low

  * [05effde] Disable mpi-test on ia64. (Closes: #729654)

 -- Anton Gladky <gladk@debian.org>  Wed, 20 Nov 2013 16:42:30 +0100

=== debian/control ===
Source: gmsh
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Christophe Prud'homme <prudhomm@debian.org>,
 Anton Gladky <gladk@debian.org>,
 Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
Build-Depends:
 chrpath,
 cmake,
 debhelper (>= 9),
 default-jdk,
 freeglut3-dev,
 gfortran,
 javahelper,
 libann-dev,
 libblas-dev,
 libcgns-dev (>= 3.1.3.2),
 libfltk1.3-dev (>=1.1.7),
 libgl1-mesa-dev,
 libgl2ps-dev,
 libglu1-mesa-dev,
 libgmm++-dev [!hurd-i386 !s390x],
 libhdf5-mpi-dev (>= 1.8.8),
 libjpeg-dev,
 liblapack-dev,
 libmed-dev (>= 2.3.6),
 libmedc-dev (>= 2.3.6),
 liboce-modeling-dev,
 liboce-ocaf-dev,
 liboce-visualization-dev,
 libpng-dev,
 libtet1.5-dev (>=1.5.0-3),
 mpi-default-dev,
 oce-draw,
 python-dev (>= 2.6.6-3~),
 swig2.0,
 texinfo,
 texlive,
 zlib1g-dev
Standards-Version: 3.9.5
X-Python-Version: current
XS-Testsuite: autopkgtest
Vcs-Git: git://anonscm.debian.org/debian-science/packages/gmsh.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/gmsh.git
Homepage: http://www.geuz.org/gmsh/

Package: gmsh
Architecture: any
Depends:
 mpi-default-bin,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 gmsh-doc
Description: Three-dimensional finite element mesh generator
 Gmsh is a 3D finite element grid generator with a build-in CAD engine
 and post-processor. Its design goal is to provide a fast, light and
 user-friendly meshing tool with parametric input and advanced
 visualization capabilities. Gmsh is built around four modules: geometry,
 mesh, solver and post-processing. The specification of any input to
 these modules is done either interactively using the graphical user
 interface or in ASCII text files using Gmsh's own scripting language.
 .
 See Gmsh's reference manual for a more thorough overview of Gmsh's
 capabilities.

Package: gmsh-doc
Architecture: all
Depends:
 mpi-default-bin,
 ${misc:Depends},
 ${shlibs:Depends}
Multi-Arch: foreign
Replaces:
 gmsh (<< 2.6.0.dfsg-3)
Breaks:
 gmsh (<< 2.6.0.dfsg-3)
Section: doc
Description: Three-dimensional finite element mesh generator
 Gmsh is a 3D finite element grid generator with a build-in CAD engine
 and post-processor. Its design goal is to provide a fast, light and
 user-friendly meshing tool with parametric input and advanced
 visualization capabilities. Gmsh is built around four modules: geometry,
 mesh, solver and post-processing. The specification of any input to
 these modules is done either interactively using the graphical user
 interface or in ASCII text files using Gmsh's own scripting language.
 .
 See Gmsh's reference manual for a more thorough overview of Gmsh's
 capabilities.
 .
 The package contains documentation and examples.

Package: libgmsh-dev
Architecture: any
Section: libdevel
Replaces:
 gmsh (<< 2.6.0.dfsg-3)
Breaks:
 gmsh (<< 2.6.0.dfsg-3)
Recommends:
 gmsh
Depends:
 libgmsh2v5 (= ${binary:Version}),
 libjava-gmsh2 (= ${binary:Version}),
 ${misc:Depends}
Multi-Arch: foreign
Description: Three-dimensional finite element mesh generator. Development files
 Gmsh is a 3D finite element grid generator with a build-in CAD engine
 and post-processor. Its design goal is to provide a fast, light and
 user-friendly meshing tool with parametric input and advanced
 visualization capabilities. Gmsh is built around four modules: geometry,
 mesh, solver and post-processing. The specification of any input to
 these modules is done either interactively using the graphical user
 interface or in ASCII text files using Gmsh's own scripting language.
 .
 See Gmsh's reference manual for a more thorough overview of Gmsh's
 capabilities.
 .
 The package contains development files.

Package: libgmsh2v5
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces: libgmsh2,
 gmsh (<< 2.6.0.dfsg-3),
 libjava-gmsh2 (<<2.7.1.dfsg-1)
Breaks:
 gmsh (<< 2.6.0.dfsg-3),
 libjava-gmsh2 (<<2.7.1.dfsg-1)
Recommends:
 gmsh
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Conflicts: libgmsh2
Description: Three-dimensional finite element mesh generator. Shared library
 Gmsh is a 3D finite element grid generator with a build-in CAD engine
 and post-processor. Its design goal is to provide a fast, light and
 user-friendly meshing tool with parametric input and advanced
 visualization capabilities. Gmsh is built around four modules: geometry,
 mesh, solver and post-processing. The specification of any input to
 these modules is done either interactively using the graphical user
 interface or in ASCII text files using Gmsh's own scripting language.
 .
 See Gmsh's reference manual for a more thorough overview of Gmsh's
 capabilities.
 .
 The package contains a shared library.

Package: libjava-gmsh2
Section: java
Architecture: any
Replaces:
 gmsh (<< 2.6.0.dfsg-3)
Breaks:
 gmsh (<< 2.6.0.dfsg-3)
Recommends:
 gmsh
Depends:
 libgmsh2v5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Multi-Arch: foreign
Description: Three-dimensional finite element mesh generator. Java wrapper
 Gmsh is a 3D finite element grid generator with a build-in CAD engine
 and post-processor. Its design goal is to provide a fast, light and
 user-friendly meshing tool with parametric input and advanced
 visualization capabilities. Gmsh is built around four modules: geometry,
 mesh, solver and post-processing. The specification of any input to
 these modules is done either interactively using the graphical user
 interface or in ASCII text files using Gmsh's own scripting language.
 .
 See Gmsh's reference manual for a more thorough overview of Gmsh's
 capabilities.
 .
 This package contains the Java wrappers for gmsh
Pre-Depends:
 ${misc:Pre-Depends}

Package: python-gmsh
Section: python
Architecture: any
Replaces:
 gmsh (<< 2.6.0.dfsg-3)
Breaks:
 gmsh (<< 2.6.0.dfsg-3)
Recommends:
 gmsh
Multi-Arch: foreign
Depends:
 libgmsh2v5 (= ${binary:Version}),
 python (<<2.8),
 python (>= 2.7),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Three-dimensional finite element mesh generator. Python wrapper
 Gmsh is a 3D finite element grid generator with a build-in CAD engine
 and post-processor. Its design goal is to provide a fast, light and
 user-friendly meshing tool with parametric input and advanced
 visualization capabilities. Gmsh is built around four modules: geometry,
 mesh, solver and post-processing. The specification of any input to
 these modules is done either interactively using the graphical user
 interface or in ASCII text files using Gmsh's own scripting language.
 .
 See Gmsh's reference manual for a more thorough overview of Gmsh's
 capabilities.
 .
 This package contains the Python wrapper for gmsh

## gmsh 2.9.3+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
+# Gmsh - Copyright (C) 1997-2015 C. Geuzaine, J.-F. Remacle
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <gmsh@geuz.org>.
@@ -63,9 +63,13 @@
 opt(NATIVE_FILE_CHOOSER "Enable native file chooser in GUI" ${DEFAULT})
 opt(NETGEN "Enable Netgen 3D frontal mesh generator" ${DEFAULT})
 opt(NUMPY "Enable conversion between fullMatrix and numpy array (requires SWIG)" OFF)
+opt(PETSC4PY "Enable petsc4py wrappers for petsc matrices" ON)
 opt(OCC "Enable Open CASCADE geometrical models" ${DEFAULT})
 opt(ONELAB "Enable ONELAB solver interface" ${DEFAULT})
 opt(ONELAB2 "Enable experimental ONELAB-Cloud solver interface" OFF)
+if(ENABLE_ONELAB2)
+  opt(UDT "Enable UDT library for ONELAB-Cloud" ON)
+endif(ENABLE_ONELAB2)
 opt(ONELAB_METAMODEL "Enable ONELAB metamodels (experimental)" ${DEFAULT})
 opt(OPENMP "Enable OpenMP (experimental)" OFF)
 opt(OPTHOM "Enable high-order mesh optimization tools" ${DEFAULT})
@@ -77,7 +81,6 @@
 opt(POST "Enable post-processing module (required by GUI)" ${DEFAULT})
 opt(POPPLER "Enable Poppler for displaying PDF documents (experimental)" OFF)
 opt(QT "Enable dummy QT graphical interface proof-of-concept (experimental)" OFF)
-opt(RTREE "Enable RTREE (used for quad/hex mesh generation)" ${DEFAULT})
 opt(SALOME "Enable Salome routines for CAD healing" ${DEFAULT})
 opt(SGEOM "Enable SGEOM interface to OCC (experimental)" OFF)
 opt(SLEPC "Enable SLEPc eigensolvers (required for conformal compounds)" ${DEFAULT})
@@ -91,8 +94,8 @@
 opt(WRAP_PYTHON "Enable generation of Python wrappers" OFF)
 
 set(GMSH_MAJOR_VERSION 2)
-set(GMSH_MINOR_VERSION 8)
-set(GMSH_PATCH_VERSION 5)
+set(GMSH_MINOR_VERSION 9)
+set(GMSH_PATCH_VERSION 3)
 set(GMSH_EXTRA_VERSION "" CACHE STRING "Gmsh extra version string")
 
 set(GMSH_VERSION "${GMSH_MAJOR_VERSION}.${GMSH_MINOR_VERSION}")
@@ -108,7 +111,9 @@
     Common/onelab.h Common/GmshSocket.h Common/onelabUtils.h
   Numeric/Numeric.h Numeric/GaussIntegration.h Numeric/polynomialBasis.h
     Numeric/JacobianBasis.h Numeric/MetricBasis.h Numeric/bezierBasis.h Numeric/fullMatrix.h
+    Numeric/FuncSpaceData.h
     Numeric/simpleFunction.h Numeric/cartesian.h Numeric/ElementType.h
+    Numeric/BasisFactory.h
   Geo/GModel.h Geo/GEntity.h Geo/GPoint.h Geo/GVertex.h Geo/GEdge.h 
     Geo/GFace.h Geo/GRegion.h Geo/GEdgeLoop.h Geo/GEdgeCompound.h 
     Geo/GFaceCompound.h Geo/GRegionCompound.h Geo/GRbf.h Geo/MVertex.h
@@ -120,6 +125,7 @@
     Geo/SPoint2.h Geo/SPoint3.h Geo/SVector3.h Geo/STensor3.h Geo/SBoundingBox3d.h 
     Geo/Pair.h Geo/Range.h Geo/SOrientedBoundingBox.h 
     Geo/CellComplex.h Geo/ChainComplex.h Geo/Cell.h Geo/Homology.h Geo/Chain.h 
+    Geo/GenericVertex.h Geo/GenericEdge.h Geo/GenericFace.h Geo/GenericRegion.h
     Geo/partitionEdge.h Geo/CGNSOptions.h Geo/gmshLevelset.h Geo/boundaryLayersData.h
   Mesh/meshGEdge.h Mesh/meshGFace.h Mesh/meshGFaceOptimize.h 
     Mesh/meshGFaceElliptic.h Mesh/meshPartition.h Mesh/meshGFaceDelaunayInsertion.h 
@@ -131,6 +137,7 @@
     Solver/linearSystem.h Solver/linearSystemGMM.h Solver/linearSystemCSR.h 
     Solver/linearSystemFull.h Solver/elasticitySolver.h Solver/sparsityPattern.h 
     Solver/groupOfElements.h Solver/linearSystemPETSc.h Solver/linearSystemMUMPS.h
+    Solver/thermicSolver.h
   Post/PView.h Post/PViewData.h Plugin/PluginManager.h Post/OctreePost.h 
   Post/PViewDataList.h Post/PViewDataGModel.h Post/PViewOptions.h Post/ColorTable.h
    Numeric/nodalBasis.h
@@ -141,6 +148,19 @@
   contrib/HighOrderMeshOptimizer/OptHOM.h contrib/HighOrderMeshOptimizer/OptHomMesh.h
   contrib/HighOrderMeshOptimizer/OptHomRun.h contrib/HighOrderMeshOptimizer/ParamCoord.h
   contrib/HighOrderMeshOptimizer/OptHomFastCurving.h contrib/HighOrderMeshOptimizer/SuperEl.h
+  contrib/HighOrderMeshOptimizer/OptHomIntegralBoundaryDist.h
+  contrib/HighOrderMeshOptimizer/CADDistances.h
+  contrib/HighOrderMeshOptimizer/OptHomObjContribScaledJac.h
+  contrib/HighOrderMeshOptimizer/OptHomObjContribMetricMin.h
+  contrib/HighOrderMeshOptimizer/OptHomObjContribCADDist.h
+  contrib/MeshOptimizer/MeshOptPatch.h contrib/MeshOptimizer/MeshOpt.h
+  contrib/MeshOptimizer/MeshOptCommon.h contrib/MeshOptimizer/MeshOptimizer.h
+  contrib/MeshOptimizer/MeshOptObjContribFunc.h contrib/MeshOptimizer/MeshOptObjContrib.h
+  contrib/MeshOptimizer/MeshOptObjContribScaledNodeDispSq.h
+  contrib/MeshOptimizer/MeshOptObjectiveFunction.h contrib/MeshOptimizer/MeshOptVertexCoord.h 
+  contrib/MeshQualityOptimizer/MeshQualityObjContribIdealJac.h
+  contrib/MeshQualityOptimizer/MeshQualityObjContribInvCond.h
+  contrib/MeshQualityOptimizer/MeshQualityOptimizer.h
   contrib/MathEx/mathex.h)
 
 get_property(IAMCHILD DIRECTORY  PROPERTY PARENT_DIRECTORY)
@@ -217,36 +237,3 @@
 
 macro(find_all_libraries VARNAME LISTNAME PATH SUFFIX)
   set(${VARNAME})
-  list(LENGTH ${LISTNAME} NUM_LIST)
-  foreach(LIB ${${LISTNAME}})
-    find_library(FOUND_LIB ${LIB} PATHS ${PATH} PATH_SUFFIXES ${SUFFIX})
-    if(FOUND_LIB)
-      list(APPEND ${VARNAME} ${FOUND_LIB})
-    endif(FOUND_LIB)
-    unset(FOUND_LIB CACHE)
-  endforeach(LIB)
-  list(LENGTH ${VARNAME} NUM_FOUND_LIBRARIES)
-  if(NUM_FOUND_LIBRARIES LESS NUM_LIST)
-    set(${VARNAME})
-  endif(NUM_FOUND_LIBRARIES LESS NUM_LIST)
-endmacro(find_all_libraries)
-
-macro(set_config_option VARNAME STRING)
-  set(${VARNAME} TRUE)
-  list(APPEND CONFIG_OPTIONS ${STRING})
-  message(STATUS "Found " ${STRING})
-endmacro(set_config_option)
-
-# check if the machine is 64 bits (this is more reliable than using
-# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
-# machines)
-check_type_size("void*" SIZEOF_VOID_P)
-if(SIZEOF_VOID_P EQUAL 8)
-  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
-endif(SIZEOF_VOID_P EQUAL 8)
-
-if(ENABLE_BLAS_LAPACK)
-  if(BLAS_LAPACK_LIBRARIES)
-    # use libs as specified in the BLAS_LAPACK_LIBRARIES variable
-    set_config_option(HAVE_BLAS "Blas(Custom)")
-    set_config_option(HAVE_LAPACK "Lapack(Custom)")

=== Common/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,10 @@
-# Gmsh - Copyright (C) 1997-2014 C. Geuzaine, J.-F. Remacle
+# Gmsh - Copyright (C) 1997-2015 C. Geuzaine, J.-F. Remacle
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <gmsh@geuz.org>.
 
 set(SRC  
   Gmsh.cpp
-    GmshRemote.cpp
     GmshMessage.cpp
   gmshPopplerWrapper.cpp
   Context.cpp
@@ -24,6 +23,8 @@
   MallocUtils.cpp
   onelabUtils.cpp
   GamePad.cpp
+  GmshRemote.cpp
+  gmshLocalNetworkClient.cpp
 )
 
 file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

=== contrib/onelab2/CMakeLists.txt ===
set(SRC
  NetworkUtils.cpp
  OnelabAttributes.cpp
  OnelabDatabase.cpp
  OnelabProtocol.cpp
  OnelabLocalNetworkClient.cpp
  OnelabServer.cpp
  OnelabNetworkClient.cpp
  GmshNetworkClient.cpp
  GmshLocalClient.cpp)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/onelab2 "${SRC};${HDR}")

# build only the server
if(HAVE_UDT)
	find_package(Threads REQUIRED)
	find_path(UDT_INCLUDE_DIR udt.h PATH_SUFFIXES include udt)
	find_library(UDT_LIBRARY udt)
	if(UDT_INCLUDE_DIR AND UDT_LIBRARY AND Threads_FOUND)
		list(APPEND EXTERNAL_INCLUDES ${UDT_INCLUDE_DIR})
		list(APPEND EXTERNAL_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
		list(APPEND EXTERNAL_LIBRARIES ${UDT_LIBRARY})
	else(UDT_INCLUDE_DIR AND UDT_LIBRARY AND Threads_FOUND)
		message(FATAL_ERROR "Unable to find UDT library")
	endif(UDT_INCLUDE_DIR AND UDT_LIBRARY AND Threads_FOUND)
endif(HAVE_UDT)

include_directories(${CMAKE_SOURCE_DIR}/Common/) # for onelab.h
include_directories(${CMAKE_BINARY_DIR}/Common/) # for GmshConfig.h
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/)
include_directories(${EXTERNAL_INCLUDES}) # for UDT
add_executable (onelabserver Onelab.cpp OnelabServer.cpp OnelabNetworkClient.cpp OnelabLocalNetworkClient.cpp NetworkUtils.cpp OnelabProtocol.cpp OnelabAttributes.cpp) 
target_link_libraries(onelabserver ${EXTERNAL_LIBRARIES})

=== debian/changelog ===
gmsh (2.9.3+dfsg1-1ubuntu1) wily; urgency=medium

  [ Martin Pitt ]
  * Merge with Debian. Remaining Ubuntu changes:
    - Enable mpi on armhf.
    - Enable building on any architectures.

  [ Steve Langasek ]
  * Rename library packages for g++5 ABI transition. (Closes: #791054)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 05 Aug 2015 09:21:04 +0200

gmsh (2.9.3+dfsg1-1) unstable; urgency=medium

  * [9d1319c] Update d/copyright.
  * [136ee92] Update, refresh, rename patches.
  * [f7b8539] Remove README.source
  * [1a675ed] Apply cme fix dpkg-control.
  * [15c506b] Imported Upstream version 2.9.3+dfsg1
  * [a2fc60f] Update changelog.
  * [14b7739] Add mpi-default-bin into BD.
  * [af16049] Move libjava-gmsh.so into libjava-gmsh2.
  * [a7dd03b] Relax check of python versions.
  * [d758ae5] Move debian/upstream -> debian/upstream/metadata

 -- Anton Gladky <gladk@debian.org>  Tue, 26 May 2015 22:08:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,60 +1,55 @@
 Source: gmsh
-Section: math
-Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders:
- Christophe Prud'homme <prudhomm@debian.org>,
- Anton Gladky <gladk@debian.org>,
- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
-Build-Depends:
- chrpath,
- cmake,
- debhelper (>= 9),
- default-jdk,
- freeglut3-dev,
- gfortran,
- javahelper,
- libann-dev,
- libblas-dev,
- libcgns-dev (>= 3.1.3.2),
- libfltk1.3-dev (>=1.1.7),
- libgl1-mesa-dev,
- libgl2ps-dev,
- libglu1-mesa-dev,
- libgmm++-dev [!hurd-i386 !s390x],
- libhdf5-mpi-dev (>= 1.8.8),
- libjpeg-dev,
- liblapack-dev,
- libmed-dev (>= 2.3.6),
- libmedc-dev (>= 2.3.6),
- liboce-modeling-dev,
- liboce-ocaf-dev,
- liboce-visualization-dev,
- libpng-dev,
- libtet1.5-dev (>=1.5.0-3),
- mpi-default-dev,
- oce-draw,
- python-dev (>= 2.6.6-3~),
- swig2.0,
- texinfo,
- texlive,
- zlib1g-dev
-Standards-Version: 3.9.5
+Uploaders: Christophe Prud'homme <prudhomm@debian.org>,
+           Anton Gladky <gladk@debian.org>,
+           Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
+Section: math
+Testsuite: autopkgtest
+Priority: optional
+Build-Depends: chrpath,
+               cmake,
+               debhelper (>= 9),
+               default-jdk,
+               freeglut3-dev,
+               gfortran,
+               javahelper,
+               libann-dev,
+               libblas-dev,
+               libcgns-dev (>= 3.1.3.2),
+               libfltk1.3-dev,
+               libgl1-mesa-dev,
+               libgl2ps-dev,
+               libglu1-mesa-dev,
+               libjpeg-dev,
+               liblapack-dev,
+               libmed-dev,
+               libmedc-dev,
+               liboce-modeling-dev,
+               liboce-ocaf-dev,
+               liboce-visualization-dev,
+               libpng-dev,
+               libtet1.5-dev,
+               mpi-default-bin,
+               mpi-default-dev,
+               oce-draw,
+               python-dev,
+               swig2.0,
+               texinfo,
+               texlive,
+               zlib1g-dev
+Standards-Version: 3.9.6
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/gmsh.git
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/gmsh.git
+Homepage: http://www.geuz.org/gmsh/
 X-Python-Version: current
-XS-Testsuite: autopkgtest
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/gmsh.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/gmsh.git
-Homepage: http://www.geuz.org/gmsh/
 
 Package: gmsh
 Architecture: any
-Depends:
- mpi-default-bin,
- ${misc:Depends},
- ${shlibs:Depends}
-Recommends:
- gmsh-doc
+Depends: mpi-default-bin,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Recommends: gmsh-doc
 Description: Three-dimensional finite element mesh generator
  Gmsh is a 3D finite element grid generator with a build-in CAD engine
  and post-processor. Its design goal is to provide a fast, light and
@@ -69,16 +64,13 @@
 
 Package: gmsh-doc
 Architecture: all
-Depends:
- mpi-default-bin,
- ${misc:Depends},
- ${shlibs:Depends}
 Multi-Arch: foreign
-Replaces:
- gmsh (<< 2.6.0.dfsg-3)
-Breaks:
- gmsh (<< 2.6.0.dfsg-3)
 Section: doc
+Depends: mpi-default-bin,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Breaks: gmsh (<< 2.6.0.dfsg-3)
+Replaces: gmsh (<< 2.6.0.dfsg-3)
 Description: Three-dimensional finite element mesh generator
  Gmsh is a 3D finite element grid generator with a build-in CAD engine
  and post-processor. Its design goal is to provide a fast, light and
@@ -95,18 +87,14 @@
 
 Package: libgmsh-dev
 Architecture: any
+Multi-Arch: foreign
 Section: libdevel
-Replaces:
- gmsh (<< 2.6.0.dfsg-3)
-Breaks:
- gmsh (<< 2.6.0.dfsg-3)
-Recommends:
- gmsh
-Depends:
- libgmsh2v5 (= ${binary:Version}),
- libjava-gmsh2 (= ${binary:Version}),
- ${misc:Depends}
-Multi-Arch: foreign
+Depends: libgmsh2v5 (= ${binary:Version}),
+         libjava-gmsh2 (= ${binary:Version}),
+         ${misc:Depends}
+Recommends: gmsh
+Breaks: gmsh (<< 2.6.0.dfsg-3)
+Replaces: gmsh (<< 2.6.0.dfsg-3)
 Description: Three-dimensional finite element mesh generator. Development files
  Gmsh is a 3D finite element grid generator with a build-in CAD engine
  and post-processor. Its design goal is to provide a fast, light and
@@ -123,21 +111,16 @@
 
 Package: libgmsh2v5
 Architecture: any
+Multi-Arch: same
 Section: libs
-Depends:
- ${misc:Depends},
- ${shlibs:Depends}
-Replaces: libgmsh2,
- gmsh (<< 2.6.0.dfsg-3),
- libjava-gmsh2 (<<2.7.1.dfsg-1)
-Breaks:
- gmsh (<< 2.6.0.dfsg-3),
- libjava-gmsh2 (<<2.7.1.dfsg-1)
-Recommends:
- gmsh
-Multi-Arch: same
-Pre-Depends:
- ${misc:Pre-Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
+Recommends: gmsh
+Pre-Depends: ${misc:Pre-Depends}
+Breaks: gmsh (<< 2.6.0.dfsg-3),
+        libjava-gmsh2 (<< 2.7.1.dfsg-1)
+Replaces: gmsh (<< 2.6.0.dfsg-3),
+          libjava-gmsh2 (<< 2.7.1.dfsg-1), libgmsh2
 Conflicts: libgmsh2
 Description: Three-dimensional finite element mesh generator. Shared library
  Gmsh is a 3D finite element grid generator with a build-in CAD engine
@@ -154,19 +137,16 @@
  The package contains a shared library.
 
 Package: libjava-gmsh2
+Architecture: any
+Multi-Arch: foreign
 Section: java
-Architecture: any
-Replaces:
- gmsh (<< 2.6.0.dfsg-3)
-Breaks:
- gmsh (<< 2.6.0.dfsg-3)
-Recommends:
- gmsh
-Depends:
- libgmsh2v5 (= ${binary:Version}),
- ${misc:Depends},
- ${shlibs:Depends}
-Multi-Arch: foreign
+Depends: libgmsh2v5 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
+Recommends: gmsh
+Pre-Depends: ${misc:Pre-Depends}
+Breaks: gmsh (<< 2.6.0.dfsg-3)
+Replaces: gmsh (<< 2.6.0.dfsg-3)
 Description: Three-dimensional finite element mesh generator. Java wrapper
  Gmsh is a 3D finite element grid generator with a build-in CAD engine
  and post-processor. Its design goal is to provide a fast, light and
@@ -180,25 +160,19 @@
  capabilities.
  .
  This package contains the Java wrappers for gmsh
-Pre-Depends:
- ${misc:Pre-Depends}
 
 Package: python-gmsh
+Architecture: any
+Multi-Arch: foreign
 Section: python
-Architecture: any
-Replaces:
- gmsh (<< 2.6.0.dfsg-3)
-Breaks:
- gmsh (<< 2.6.0.dfsg-3)
-Recommends:
- gmsh
-Multi-Arch: foreign
-Depends:
- libgmsh2v5 (= ${binary:Version}),
- python (<<2.8),
- python (>= 2.7),
- ${misc:Depends},
- ${shlibs:Depends}
+Depends: libgmsh2v5 (= ${binary:Version}),
+         python (<< 2.8),
+         python (>= 2.7),
+         ${misc:Depends},
+         ${shlibs:Depends}
+Recommends: gmsh
+Breaks: gmsh (<< 2.6.0.dfsg-3)
+Replaces: gmsh (<< 2.6.0.dfsg-3)
 Description: Three-dimensional finite element mesh generator. Python wrapper
  Gmsh is a 3D finite element grid generator with a build-in CAD engine
  and post-processor. Its design goal is to provide a fast, light and
